#include "aubo_sdk/rpc.h"

void read_test()
{
    auto rpc_client = std::make_shared<arcs::aubo_sdk::RpcClient>();
    rpc_client->setRequestTimeout(1000);
    rpc_client->connect("127.0.0.1", 30004);
    rpc_client->login("aubo", "123456");
    auto robot_name = rpc_client->getRobotNames().front();
    auto impl = rpc_client->getRobotInterface(robot_name);

    std::vector<std::thread> ths;
    for (int i = 0; i < 10; i++) {
        ths.emplace_back([&]() {
            while (1) {
                try {
                    impl->getRobotConfig()->getTcpOffset();
                    std::cerr << "·" << std::flush;
                } catch (const arcs::aubo_sdk::AuboException &e) {
                    std::cerr << std::this_thread::get_id() << ":" << e.what()
                              << std::endl;
                }
                std::this_thread::sleep_for(std::chrono::milliseconds(5));
            }
        });
    }

    for (auto &t : ths) {
        t.join();
    }
}

void connect_test()
{
    std::vector<std::thread> ths;
    for (int i = 0; i < 10; i++) {
        ths.emplace_back([&]() {
            auto rpc_client = std::make_shared<arcs::aubo_sdk::RpcClient>();
            rpc_client->setRequestTimeout(1000);
            while (1) {
                try {
                    rpc_client->connect("127.0.0.1", 30004);
                    rpc_client->login("aubo", "123456");
                    std::this_thread::sleep_for(std::chrono::milliseconds(7));
                    rpc_client->logout();
                    rpc_client->disconnect();
                    std::this_thread::sleep_for(std::chrono::milliseconds(7));
                } catch (const arcs::aubo_sdk::AuboException &e) {
                    std::cerr << std::this_thread::get_id() << ":" << e.what()
                              << std::endl;
                }
            }
        });
    }

    for (auto &t : ths) {
        t.join();
    }
}
int main(int argc, char **argv)
{
    connect_test();
    // read_test();

    return 0;
}
