#include <math.h>
#include <unistd.h>
#include "aubo_sdk/rpc.h"

using namespace arcs::common_interface;
using namespace arcs::aubo_sdk;

#define LOCAL_IP "127.0.0.1"

int main(int argc, char **argv)
{
    auto rpc_cli = std::make_shared<RpcClient>();
    rpc_cli->connect(LOCAL_IP, 30004);
    rpc_cli->login("aubo", "123456");
    rpc_cli->setRequestTimeout(1000);
    auto name = rpc_cli->getRobotNames().front();
    auto impl = rpc_cli->getRobotInterface(name);

    std::cout << "example1---------------" << std::endl;
    {
        rpc_cli->getRuntimeMachine()->timerStart("timer1");
        usleep(1000 * 1000 * 7.5);
        rpc_cli->getRuntimeMachine()->timerStop("timer1");
        std::cout << rpc_cli->getRuntimeMachine()->getTimer("timer1")
                  << std::endl;

        rpc_cli->getRuntimeMachine()->timerStart("timer1");
        usleep(1000 * 1000 * 7.5);
        rpc_cli->getRuntimeMachine()->timerStop("timer1");
        std::cout << rpc_cli->getRuntimeMachine()->getTimer("timer1")
                  << std::endl;

        rpc_cli->getRuntimeMachine()->timerReset("timer1");
        std::cout << rpc_cli->getRuntimeMachine()->getTimer("timer1")
                  << std::endl;
        rpc_cli->getRuntimeMachine()->timerDelete("timer1");
    }

    std::cout << "example2---------------" << std::endl;
    {
        rpc_cli->getRuntimeMachine()->timerStart("timer1");
        usleep(1000 * 1000 * 7.5);
        std::cout << rpc_cli->getRuntimeMachine()->getTimer("timer1")
                  << std::endl;
        rpc_cli->getRuntimeMachine()->timerReset("timer1");

        rpc_cli->getRuntimeMachine()->timerStart("timer1");
        usleep(1000 * 1000 * 7.5);
        std::cout << rpc_cli->getRuntimeMachine()->getTimer("timer1")
                  << std::endl;
        rpc_cli->getRuntimeMachine()->timerReset("timer1");
        rpc_cli->getRuntimeMachine()->timerDelete("timer1");
    }
}
